"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

class point_t(object):
    """
     Standard message to represent the position of a point in free space.
    
    """

    __slots__ = ["x", "y", "z"]

    __typenames__ = ["double", "double", "double"]

    __dimensions__ = [None, None, None]

    def __init__(self):
        self.x = 0.0
        """
        Position coordinates X, Y, Z.
        LCM Type: double
        """

        self.y = 0.0
        """ LCM Type: double """
        self.z = 0.0
        """ LCM Type: double """

    def encode(self):
        buf = BytesIO()
        buf.write(point_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">ddd", self.x, self.y, self.z))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != point_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return point_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = point_t()
        self.x, self.y, self.z = struct.unpack(">ddd", buf.read(24))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if point_t in parents: return 0
        tmphash = (0x573f2fdd2f76508f) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if point_t._packed_fingerprint is None:
            point_t._packed_fingerprint = struct.pack(">Q", point_t._get_hash_recursive([]))
        return point_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", point_t._get_packed_fingerprint())[0]

