"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.geolcm

import compas_lcmtypes.stdlcm

class odometry_t(object):
    """
     Standard message to report the odometry of a system.
    
    """

    __slots__ = ["header", "pose", "twist"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "compas_lcmtypes.geolcm.pose_with_covariance_t", "compas_lcmtypes.geolcm.twist_with_covariance_t"]

    __dimensions__ = [None, None, None]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.pose = compas_lcmtypes.geolcm.pose_with_covariance_t()
        """
        Pose as a pose with covariance structure from the geolcm package.
        LCM Type: compas_lcmtypes.geolcm.pose_with_covariance_t
        """

        self.twist = compas_lcmtypes.geolcm.twist_with_covariance_t()
        """
        Twist as a twist with covariance structure from the geolcm package.
        LCM Type: compas_lcmtypes.geolcm.twist_with_covariance_t
        """


    def encode(self):
        buf = BytesIO()
        buf.write(odometry_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        assert self.pose._get_packed_fingerprint() == compas_lcmtypes.geolcm.pose_with_covariance_t._get_packed_fingerprint()
        self.pose._encode_one(buf)
        assert self.twist._get_packed_fingerprint() == compas_lcmtypes.geolcm.twist_with_covariance_t._get_packed_fingerprint()
        self.twist._encode_one(buf)

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != odometry_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return odometry_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = odometry_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.pose = compas_lcmtypes.geolcm.pose_with_covariance_t._decode_one(buf)
        self.twist = compas_lcmtypes.geolcm.twist_with_covariance_t._decode_one(buf)
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if odometry_t in parents: return 0
        newparents = parents + [odometry_t]
        tmphash = (0x633953ab14181e13+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)+ compas_lcmtypes.geolcm.pose_with_covariance_t._get_hash_recursive(newparents)+ compas_lcmtypes.geolcm.twist_with_covariance_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if odometry_t._packed_fingerprint is None:
            odometry_t._packed_fingerprint = struct.pack(">Q", odometry_t._get_hash_recursive([]))
        return odometry_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", odometry_t._get_packed_fingerprint())[0]

