"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class position_t(object):
    """
     Standard message to report XYZ cartesian position.
    
    """

    __slots__ = ["header", "xyz", "xyz_cov"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "double", "double"]

    __dimensions__ = [None, [3], [9]]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.xyz = [ 0.0 for dim0 in range(3) ]
        """
        XYZ cartesian position as a list of three values.
        SI units = m.
        LCM Type: double[3]
        """

        self.xyz_cov = [ 0.0 for dim0 in range(9) ]
        """
        XYZ cartesian position as a list of three values.
        SI units = m^2.
        LCM Type: double[9]
        """


    def encode(self):
        buf = BytesIO()
        buf.write(position_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack('>3d', *self.xyz[:3]))
        buf.write(struct.pack('>9d', *self.xyz_cov[:9]))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != position_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return position_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = position_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.xyz = struct.unpack('>3d', buf.read(24))
        self.xyz_cov = struct.unpack('>9d', buf.read(72))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if position_t in parents: return 0
        newparents = parents + [position_t]
        tmphash = (0x4ad0f080677f06f1+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if position_t._packed_fingerprint is None:
            position_t._packed_fingerprint = struct.pack(">Q", position_t._get_hash_recursive([]))
        return position_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", position_t._get_packed_fingerprint())[0]

