"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.geolcm

import compas_lcmtypes.stdlcm

class twist_t(object):
    """
     Standard message to report a twist with covariance.
    
    """

    __slots__ = ["header", "twist", "twist_covariance"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "compas_lcmtypes.geolcm.twist_t", "double"]

    __dimensions__ = [None, None, [36]]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.twist = compas_lcmtypes.geolcm.twist_t()
        """
        Twist as a twist structure from the geolcm package.
        LCM Type: compas_lcmtypes.geolcm.twist_t
        """

        self.twist_covariance = [ 0.0 for dim0 in range(36) ]
        """
        Covariance matrix.
        LCM Type: double[36]
        """


    def encode(self):
        buf = BytesIO()
        buf.write(twist_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        assert self.twist._get_packed_fingerprint() == compas_lcmtypes.geolcm.twist_t._get_packed_fingerprint()
        self.twist._encode_one(buf)
        buf.write(struct.pack('>36d', *self.twist_covariance[:36]))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != twist_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return twist_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = twist_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.twist = compas_lcmtypes.geolcm.twist_t._decode_one(buf)
        self.twist_covariance = struct.unpack('>36d', buf.read(288))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if twist_t in parents: return 0
        newparents = parents + [twist_t]
        tmphash = (0x8807c70766588d61+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)+ compas_lcmtypes.geolcm.twist_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if twist_t._packed_fingerprint is None:
            twist_t._packed_fingerprint = struct.pack(">Q", twist_t._get_hash_recursive([]))
        return twist_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", twist_t._get_packed_fingerprint())[0]

