"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class cmd_list_t(object):
    """
     Standard message to send list of commands to a predefined number of actuators.
    
    """

    __slots__ = ["header", "len", "commands"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "int32_t", "double"]

    __dimensions__ = [None, None, ["len"]]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.len = 0
        """
        Number of actuators as an ineteger.
        LCM Type: int32_t
        """

        self.commands = []
        """
        Variable length list of commands as doubles.
        LCM Type: double[len]
        """


    def encode(self):
        buf = BytesIO()
        buf.write(cmd_list_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack(">i", self.len))
        buf.write(struct.pack('>%dd' % self.len, *self.commands[:self.len]))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != cmd_list_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return cmd_list_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = cmd_list_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.len = struct.unpack(">i", buf.read(4))[0]
        self.commands = struct.unpack('>%dd' % self.len, buf.read(self.len * 8))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if cmd_list_t in parents: return 0
        newparents = parents + [cmd_list_t]
        tmphash = (0x119a6401e6709630+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if cmd_list_t._packed_fingerprint is None:
            cmd_list_t._packed_fingerprint = struct.pack(">Q", cmd_list_t._get_hash_recursive([]))
        return cmd_list_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", cmd_list_t._get_packed_fingerprint())[0]

