"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class dvl_t(object):
    """
     Standard message for Doppler Velocity Loggers (DVLs).
    
    """

    __slots__ = ["header", "time_sensor", "btv", "wtv", "range", "altitude"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "int64_t", "double", "double", "double", "double"]

    __dimensions__ = [None, None, [4], [4], [4], None]

    BTV_SENTINAL = -32.768
    """ x_dot, y_dot, z_dot, error [m/s] """
    WTV_SENTINAL = -32.768
    """ x_dot, y_dot, z_dot, error [m/s] """

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.time_sensor = 0
        """
        Sensor time in microseconds.
        LCM Type: int64_t
        """

        self.btv = [ 0.0 for dim0 in range(4) ]
        """
         These fields contain the velocity of the vessel in relation to the bottom
        in m/s. Positive values indicate vessel motion to the north (X), east (Y),
        and down (Z). When a velocity is bad, the value is set to -32.768.
        SI units = m/s
        
        LCM Type: double[4]
        """

        self.wtv = [ 0.0 for dim0 in range(4) ]
        """
         These fields contain the velocity of the vessel in relation to the water-mass
        reference layer in m/s. Positive values indicate vessel motion to the north
        (X), east (Y), and down (Z). When a velocity is bad, the value is set to -32.768.
        SI units = m/s
        
        LCM Type: double[4]
        """

        self.range = [ 0.0 for dim0 in range(4) ]
        """
         These fields contain the beam slant range to the bottom as determined by each
        beam. When the bottom detection is bad, the field is set to 0
        SI units = m
        
        LCM Type: double[4]
        """

        self.altitude = 0.0
        """
        [b1, b2, b3, b4]
         These fields contain the average vertical range to the bottom. The vertical
        range does not compensate for the effects of pitch and roll. When a bottom
        detection is bad, the field is set to 0.
        SI units = m
        
        LCM Type: double
        """


    def encode(self):
        buf = BytesIO()
        buf.write(dvl_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack(">q", self.time_sensor))
        buf.write(struct.pack('>4d', *self.btv[:4]))
        buf.write(struct.pack('>4d', *self.wtv[:4]))
        buf.write(struct.pack('>4d', *self.range[:4]))
        buf.write(struct.pack(">d", self.altitude))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != dvl_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return dvl_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = dvl_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.time_sensor = struct.unpack(">q", buf.read(8))[0]
        self.btv = struct.unpack('>4d', buf.read(32))
        self.wtv = struct.unpack('>4d', buf.read(32))
        self.range = struct.unpack('>4d', buf.read(32))
        self.altitude = struct.unpack(">d", buf.read(8))[0]
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if dvl_t in parents: return 0
        newparents = parents + [dvl_t]
        tmphash = (0x7a3abd96523cc33c+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if dvl_t._packed_fingerprint is None:
            dvl_t._packed_fingerprint = struct.pack(">Q", dvl_t._get_hash_recursive([]))
        return dvl_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", dvl_t._get_packed_fingerprint())[0]

