"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class gps_fix_t(object):
    """
     Standard message for GPS fixes.
    
    """

    __slots__ = ["header", "latitude", "longitude", "altitude"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "double", "double", "double"]

    __dimensions__ = [None, None, None, None]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.latitude = 0.0
        """
        Latitude.
        SI units = degrees.
        LCM Type: double
        """

        self.longitude = 0.0
        """
        Longitude.
        SI units = degrees.
        LCM Type: double
        """

        self.altitude = 0.0
        """
        Altitude.
        SI units = m.
        LCM Type: double
        """


    def encode(self):
        buf = BytesIO()
        buf.write(gps_fix_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack(">ddd", self.latitude, self.longitude, self.altitude))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != gps_fix_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return gps_fix_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = gps_fix_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.latitude, self.longitude, self.altitude = struct.unpack(">ddd", buf.read(24))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if gps_fix_t in parents: return 0
        newparents = parents + [gps_fix_t]
        tmphash = (0xbf8512fa9517e9f+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if gps_fix_t._packed_fingerprint is None:
            gps_fix_t._packed_fingerprint = struct.pack(">Q", gps_fix_t._get_hash_recursive([]))
        return gps_fix_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", gps_fix_t._get_packed_fingerprint())[0]

