"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class pth_t(object):
    """
     Standard message for pressure, temperature, and humidity sensors.
    
    """

    __slots__ = ["header", "pressure_hpa", "temperature_degc", "humidity_rh"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "double", "double", "double"]

    __dimensions__ = [None, None, None, None]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.pressure_hpa = 0.0
        """
        Pressure as a double.
        SI units = hectopascal.
        LCM Type: double
        """

        self.temperature_degc = 0.0
        """
        Temperature as a double.
        SI units = Celsius.
        LCM Type: double
        """

        self.humidity_rh = 0.0
        """
        Humidity as a double.
        SI units = relative humidity, %RH
        LCM Type: double
        """


    def encode(self):
        buf = BytesIO()
        buf.write(pth_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack(">ddd", self.pressure_hpa, self.temperature_degc, self.humidity_rh))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != pth_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return pth_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = pth_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.pressure_hpa, self.temperature_degc, self.humidity_rh = struct.unpack(">ddd", buf.read(24))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if pth_t in parents: return 0
        newparents = parents + [pth_t]
        tmphash = (0x4c343ee09fc9b0c0+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if pth_t._packed_fingerprint is None:
            pth_t._packed_fingerprint = struct.pack(">Q", pth_t._get_hash_recursive([]))
        return pth_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", pth_t._get_packed_fingerprint())[0]

