"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

import compas_lcmtypes.stdlcm

class rph_t(object):
    """
     Standard message to report attitude from a inertial measurement unit (IMU).
    
    """

    __slots__ = ["header", "rph"]

    __typenames__ = ["compas_lcmtypes.stdlcm.header_t", "double"]

    __dimensions__ = [None, [3]]

    def __init__(self):
        self.header = compas_lcmtypes.stdlcm.header_t()
        """
        Standard header.
        LCM Type: compas_lcmtypes.stdlcm.header_t
        """

        self.rph = [ 0.0 for dim0 in range(3) ]
        """
        Attitude in roll, pitch, heading convention as a list of three values.
        SI units = rad.
        LCM Type: double[3]
        """


    def encode(self):
        buf = BytesIO()
        buf.write(rph_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        assert self.header._get_packed_fingerprint() == compas_lcmtypes.stdlcm.header_t._get_packed_fingerprint()
        self.header._encode_one(buf)
        buf.write(struct.pack('>3d', *self.rph[:3]))

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != rph_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return rph_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = rph_t()
        self.header = compas_lcmtypes.stdlcm.header_t._decode_one(buf)
        self.rph = struct.unpack('>3d', buf.read(24))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if rph_t in parents: return 0
        newparents = parents + [rph_t]
        tmphash = (0xab41f2db582f8e94+ compas_lcmtypes.stdlcm.header_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if rph_t._packed_fingerprint is None:
            rph_t._packed_fingerprint = struct.pack(">Q", rph_t._get_hash_recursive([]))
        return rph_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", rph_t._get_packed_fingerprint())[0]

