"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""


from io import BytesIO
import struct

class header_t(object):
    """
     Standard metadata to stamp other lcmtypes given a timestamp, a sequence id
    and coordinate frame.
    
    """

    __slots__ = ["sequence", "timestamp", "frame_id"]

    __typenames__ = ["int32_t", "int64_t", "string"]

    __dimensions__ = [None, None, None]

    def __init__(self):
        self.sequence = 0
        """
        Sequence number of published packet consecutively increasing.
        LCM Type: int32_t
        """

        self.timestamp = 0
        """
        Epoch time in microseconds.
        LCM Type: int64_t
        """

        self.frame_id = ""
        """
        Frame this data is associated with.
        LCM Type: string
        """


    def encode(self):
        buf = BytesIO()
        buf.write(header_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">iq", self.sequence, self.timestamp))
        __frame_id_encoded = self.frame_id.encode('utf-8')
        buf.write(struct.pack('>I', len(__frame_id_encoded)+1))
        buf.write(__frame_id_encoded)
        buf.write(b"\0")

    @staticmethod
    def decode(data: bytes):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != header_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return header_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        self = header_t()
        self.sequence, self.timestamp = struct.unpack(">iq", buf.read(12))
        __frame_id_len = struct.unpack('>I', buf.read(4))[0]
        self.frame_id = buf.read(__frame_id_len)[:-1].decode('utf-8', 'replace')
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        if header_t in parents: return 0
        tmphash = (0xa2111e7853888e66) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff) + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _packed_fingerprint = None

    @staticmethod
    def _get_packed_fingerprint():
        if header_t._packed_fingerprint is None:
            header_t._packed_fingerprint = struct.pack(">Q", header_t._get_hash_recursive([]))
        return header_t._packed_fingerprint

    def get_hash(self):
        """Get the LCM hash of the struct"""
        return struct.unpack(">Q", header_t._get_packed_fingerprint())[0]

